import { IdlInstructionArg } from '../idl';
import { MainCaseString } from '../shared';
import { InstructionInputValueNode } from './contextualValueNodes';
import { TypeNode } from './typeNodes';
export interface InstructionArgumentNode<TDefaultValue extends InstructionInputValueNode | undefined = InstructionInputValueNode | undefined> {
    readonly kind: 'instructionArgumentNode';
    readonly type: TypeNode;
    readonly defaultValue?: TDefaultValue;
    readonly name: MainCaseString;
    readonly docs: string[];
    readonly defaultValueStrategy?: 'optional' | 'omitted';
}
export type InstructionArgumentNodeInput<TDefaultValue extends InstructionInputValueNode | undefined = InstructionInputValueNode | undefined> = {
    readonly name: string;
    readonly type: TypeNode;
    readonly docs?: string[];
    readonly defaultValue?: TDefaultValue;
    readonly defaultValueStrategy?: 'optional' | 'omitted';
};
export declare function instructionArgumentNode<TDefaultValue extends InstructionInputValueNode | undefined = undefined>(input: InstructionArgumentNodeInput<TDefaultValue>): InstructionArgumentNode<TDefaultValue>;
export declare function instructionArgumentNodeFromIdl(idl: IdlInstructionArg): InstructionArgumentNode;
export declare function structTypeNodeFromInstructionArgumentNodes(nodes: InstructionArgumentNode[]): import("./typeNodes").StructTypeNode<(import("./typeNodes").StructFieldTypeNode<TypeNode, import("./valueNodes").ArrayValueNode<import("./valueNodes").StandaloneValueNode[]> | import("./valueNodes").BytesValueNode | import("./valueNodes").BooleanValueNode | import("./valueNodes").ConstantValueNode<TypeNode, import("./valueNodes").StandaloneValueNode> | import("./valueNodes").EnumValueNode<import("./linkNodes").DefinedTypeLinkNode, import("./valueNodes").StructValueNode<import("./valueNodes").StructFieldValueNode<import("./valueNodes").StandaloneValueNode>[]> | import("./valueNodes").TupleValueNode<import("./valueNodes").StandaloneValueNode[]> | undefined> | import("./valueNodes").MapValueNode<import("./valueNodes").MapEntryValueNode<import("./valueNodes").StandaloneValueNode, import("./valueNodes").StandaloneValueNode>[]> | import("./valueNodes").NoneValueNode | import("./valueNodes").NumberValueNode | import("./valueNodes").SetValueNode<import("./valueNodes").StandaloneValueNode[]> | import("./valueNodes").SomeValueNode<import("./valueNodes").StandaloneValueNode> | import("./valueNodes").StructValueNode<import("./valueNodes").StructFieldValueNode<import("./valueNodes").StandaloneValueNode>[]> | import("./valueNodes").TupleValueNode<import("./valueNodes").StandaloneValueNode[]> | import("./valueNodes").PublicKeyValueNode | import("./valueNodes").StringValueNode> | import("./typeNodes").StructFieldTypeNode<TypeNode, undefined>)[]>;
export declare function structFieldTypeNodeFromInstructionArgumentNode(node: InstructionArgumentNode): import("./typeNodes").StructFieldTypeNode<TypeNode, import("./valueNodes").ArrayValueNode<import("./valueNodes").StandaloneValueNode[]> | import("./valueNodes").BytesValueNode | import("./valueNodes").BooleanValueNode | import("./valueNodes").ConstantValueNode<TypeNode, import("./valueNodes").StandaloneValueNode> | import("./valueNodes").EnumValueNode<import("./linkNodes").DefinedTypeLinkNode, import("./valueNodes").StructValueNode<import("./valueNodes").StructFieldValueNode<import("./valueNodes").StandaloneValueNode>[]> | import("./valueNodes").TupleValueNode<import("./valueNodes").StandaloneValueNode[]> | undefined> | import("./valueNodes").MapValueNode<import("./valueNodes").MapEntryValueNode<import("./valueNodes").StandaloneValueNode, import("./valueNodes").StandaloneValueNode>[]> | import("./valueNodes").NoneValueNode | import("./valueNodes").NumberValueNode | import("./valueNodes").SetValueNode<import("./valueNodes").StandaloneValueNode[]> | import("./valueNodes").SomeValueNode<import("./valueNodes").StandaloneValueNode> | import("./valueNodes").StructValueNode<import("./valueNodes").StructFieldValueNode<import("./valueNodes").StandaloneValueNode>[]> | import("./valueNodes").TupleValueNode<import("./valueNodes").StandaloneValueNode[]> | import("./valueNodes").PublicKeyValueNode | import("./valueNodes").StringValueNode> | import("./typeNodes").StructFieldTypeNode<TypeNode, undefined>;
