import { ProgramIdValueNode } from '../contextualValueNodes';
import { StringEncoding, TypeNode } from '../typeNodes';
import { BytesEncoding, ValueNode } from '../valueNodes';
export interface ConstantPdaSeedNode<TType extends TypeNode = TypeNode, TValue extends ValueNode | ProgramIdValueNode = ValueNode | ProgramIdValueNode> {
    readonly kind: 'constantPdaSeedNode';
    readonly type: TType;
    readonly value: TValue;
}
export declare function constantPdaSeedNode<TType extends TypeNode, TValue extends ValueNode | ProgramIdValueNode>(type: TType, value: TValue): ConstantPdaSeedNode<TType, TValue>;
export declare function constantPdaSeedNodeFromProgramId(): ConstantPdaSeedNode<import("../typeNodes").PublicKeyTypeNode, ProgramIdValueNode>;
export declare function constantPdaSeedNodeFromString<TEncoding extends StringEncoding>(encoding: TEncoding, string: string): ConstantPdaSeedNode<import("../typeNodes").StringTypeNode<TEncoding>, import("../valueNodes").StringValueNode>;
export declare function constantPdaSeedNodeFromBytes<TEncoding extends BytesEncoding>(encoding: TEncoding, data: string): ConstantPdaSeedNode<import("../typeNodes").BytesTypeNode, import("../valueNodes").BytesValueNode>;
