import { NumberTypeNode } from '../../nodes';
import { RustImportMap } from './RustImportMap';
export type RustTypeManifest = {
    type: string;
    imports: RustImportMap;
    nestedStructs: string[];
};
export declare function getTypeManifestVisitor(): {
    setParentName: (name: string | null) => void;
    setNestedStruct: (value: boolean) => void;
    visitArrayValue: (node: import("../../nodes").ArrayValueNode<import("../../nodes").StandaloneValueNode[]>) => RustTypeManifest;
    visitBytesValue: (node: import("../../nodes").BytesValueNode) => RustTypeManifest;
    visitBooleanValue: (node: import("../../nodes").BooleanValueNode) => RustTypeManifest;
    visitConstantValue: (node: import("../../nodes").ConstantValueNode<import("../../nodes").TypeNode, import("../../nodes").StandaloneValueNode>) => RustTypeManifest;
    visitEnumValue: (node: import("../../nodes").EnumValueNode<import("../../nodes").DefinedTypeLinkNode, import("../../nodes").StructValueNode<import("../../nodes").StructFieldValueNode<import("../../nodes").StandaloneValueNode>[]> | import("../../nodes").TupleValueNode<import("../../nodes").StandaloneValueNode[]> | undefined>) => RustTypeManifest;
    visitMapValue: (node: import("../../nodes").MapValueNode<import("../../nodes").MapEntryValueNode<import("../../nodes").StandaloneValueNode, import("../../nodes").StandaloneValueNode>[]>) => RustTypeManifest;
    visitNoneValue: (node: import("../../nodes").NoneValueNode) => RustTypeManifest;
    visitNumberValue: (node: import("../../nodes").NumberValueNode) => RustTypeManifest;
    visitSetValue: (node: import("../../nodes").SetValueNode<import("../../nodes").StandaloneValueNode[]>) => RustTypeManifest;
    visitSomeValue: (node: import("../../nodes").SomeValueNode<import("../../nodes").StandaloneValueNode>) => RustTypeManifest;
    visitStructValue: (node: import("../../nodes").StructValueNode<import("../../nodes").StructFieldValueNode<import("../../nodes").StandaloneValueNode>[]>) => RustTypeManifest;
    visitTupleValue: (node: import("../../nodes").TupleValueNode<import("../../nodes").StandaloneValueNode[]>) => RustTypeManifest;
    visitPublicKeyValue: (node: import("../../nodes").PublicKeyValueNode) => RustTypeManifest;
    visitStringValue: (node: import("../../nodes").StringValueNode) => RustTypeManifest;
    visitAccountBumpValue: (node: import("../../nodes").AccountBumpValueNode) => RustTypeManifest;
    visitAccountValue: (node: import("../../nodes").AccountValueNode) => RustTypeManifest;
    visitArgumentValue: (node: import("../../nodes").ArgumentValueNode) => RustTypeManifest;
    visitConditionalValue: (node: import("../../nodes").ConditionalValueNode<import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>, import("../../nodes").StandaloneValueNode | undefined, import("../../nodes").InstructionInputValueNode | undefined, import("../../nodes").InstructionInputValueNode | undefined>) => RustTypeManifest;
    visitIdentityValue: (node: import("../../nodes").IdentityValueNode) => RustTypeManifest;
    visitPayerValue: (node: import("../../nodes").PayerValueNode) => RustTypeManifest;
    visitPdaValue: (node: import("../../nodes").PdaValueNode<import("../../nodes").PdaSeedValueNode<import("../../nodes").StandaloneValueNode | import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode>[]>) => RustTypeManifest;
    visitProgramIdValue: (node: import("../../nodes").ProgramIdValueNode) => RustTypeManifest;
    visitResolverValue: (node: import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>) => RustTypeManifest;
    visitPdaSeedValue: (node: import("../../nodes").PdaSeedValueNode<import("../../nodes").StandaloneValueNode | import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode>) => RustTypeManifest;
    visitFixedCount: (node: import("../../nodes").FixedCountNode) => RustTypeManifest;
    visitRemainderCount: (node: import("../../nodes").RemainderCountNode) => RustTypeManifest;
    visitPrefixedCount: (node: import("../../nodes").PrefixedCountNode<import("../../nodes").NestedTypeNode<NumberTypeNode<import("../../nodes").NumberFormat>>>) => RustTypeManifest;
    visitConstantDiscriminator: (node: import("../../nodes").ConstantDiscriminatorNode<import("../../nodes").ConstantValueNode<import("../../nodes").TypeNode, import("../../nodes").StandaloneValueNode>>) => RustTypeManifest;
    visitFieldDiscriminator: (node: import("../../nodes").FieldDiscriminatorNode) => RustTypeManifest;
    visitSizeDiscriminator: (node: import("../../nodes").SizeDiscriminatorNode) => RustTypeManifest;
    visitProgramLink: (node: import("../../nodes").ProgramLinkNode) => RustTypeManifest;
    visitPdaLink: (node: import("../../nodes").PdaLinkNode) => RustTypeManifest;
    visitAccountLink: (node: import("../../nodes").AccountLinkNode) => RustTypeManifest;
    visitDefinedTypeLink: (node: import("../../nodes").DefinedTypeLinkNode) => RustTypeManifest;
    visitConstantPdaSeed: (node: import("../../nodes").ConstantPdaSeedNode<import("../../nodes").TypeNode, import("../../nodes").StandaloneValueNode | import("../../nodes").ProgramIdValueNode>) => RustTypeManifest;
    visitVariablePdaSeed: (node: import("../../nodes").VariablePdaSeedNode<import("../../nodes").TypeNode>) => RustTypeManifest;
    visitAmountType: (node: import("../../nodes").AmountTypeNode<import("../../nodes").NestedTypeNode<NumberTypeNode<import("../../nodes").NumberFormat>>>) => RustTypeManifest;
    visitArrayType: (node: import("../../nodes").ArrayTypeNode<import("../../nodes").TypeNode, import("../../nodes").RegisteredCountNode>) => RustTypeManifest;
    visitBooleanType: (node: import("../../nodes").BooleanTypeNode<import("../../nodes").NestedTypeNode<NumberTypeNode<import("../../nodes").NumberFormat>>>) => RustTypeManifest;
    visitBytesType: (node: import("../../nodes").BytesTypeNode) => RustTypeManifest;
    visitDateTimeType: (node: import("../../nodes").DateTimeTypeNode<import("../../nodes").NestedTypeNode<NumberTypeNode<import("../../nodes").NumberFormat>>>) => RustTypeManifest;
    visitEnumType: (node: import("../../nodes").EnumTypeNode<import("../../nodes").EnumVariantTypeNode[], import("../../nodes").NestedTypeNode<NumberTypeNode<import("../../nodes").NumberFormat>>>) => RustTypeManifest;
    visitFixedSizeType: (node: import("../../nodes").FixedSizeTypeNode<import("../../nodes").TypeNode>) => RustTypeManifest;
    visitHiddenPrefixType: (node: import("../../nodes").HiddenPrefixTypeNode<import("../../nodes").TypeNode, import("../../nodes").ConstantValueNode<import("../../nodes").TypeNode, import("../../nodes").StandaloneValueNode>[]>) => RustTypeManifest;
    visitHiddenSuffixType: (node: import("../../nodes").HiddenSuffixTypeNode<import("../../nodes").TypeNode, import("../../nodes").ConstantValueNode<import("../../nodes").TypeNode, import("../../nodes").StandaloneValueNode>[]>) => RustTypeManifest;
    visitMapType: (node: import("../../nodes").MapTypeNode<import("../../nodes").TypeNode, import("../../nodes").TypeNode, import("../../nodes").RegisteredCountNode>) => RustTypeManifest;
    visitNumberType: (node: NumberTypeNode<import("../../nodes").NumberFormat>) => RustTypeManifest;
    visitOptionType: (node: import("../../nodes").OptionTypeNode<import("../../nodes").TypeNode, import("../../nodes").NestedTypeNode<NumberTypeNode<import("../../nodes").NumberFormat>>>) => RustTypeManifest;
    visitPostOffsetType: (node: import("../../nodes").PostOffsetTypeNode<import("../../nodes").TypeNode>) => RustTypeManifest;
    visitPreOffsetType: (node: import("../../nodes").PreOffsetTypeNode<import("../../nodes").TypeNode>) => RustTypeManifest;
    visitPublicKeyType: (node: import("../../nodes").PublicKeyTypeNode) => RustTypeManifest;
    visitSentinelType: (node: import("../../nodes").SentinelTypeNode<import("../../nodes").TypeNode, import("../../nodes").ConstantValueNode<import("../../nodes").TypeNode, import("../../nodes").StandaloneValueNode>>) => RustTypeManifest;
    visitSetType: (node: import("../../nodes").SetTypeNode<import("../../nodes").TypeNode, import("../../nodes").RegisteredCountNode>) => RustTypeManifest;
    visitSizePrefixType: (node: import("../../nodes").SizePrefixTypeNode<import("../../nodes").TypeNode, import("../../nodes").NestedTypeNode<NumberTypeNode<import("../../nodes").NumberFormat>>>) => RustTypeManifest;
    visitSolAmountType: (node: import("../../nodes").SolAmountTypeNode<import("../../nodes").NestedTypeNode<NumberTypeNode<import("../../nodes").NumberFormat>>>) => RustTypeManifest;
    visitStringType: (node: import("../../nodes").StringTypeNode<import("../../nodes").StringEncoding>) => RustTypeManifest;
    visitStructType: (node: import("../../nodes").StructTypeNode<import("../../nodes").StructFieldTypeNode<import("../../nodes").TypeNode, import("../../nodes").StandaloneValueNode | undefined>[]>) => RustTypeManifest;
    visitTupleType: (node: import("../../nodes").TupleTypeNode<import("../../nodes").TypeNode[]>) => RustTypeManifest;
    visitZeroableOptionType: (node: import("../../nodes").ZeroableOptionTypeNode<import("../../nodes").TypeNode, import("../../nodes").ConstantValueNode<import("../../nodes").TypeNode, import("../../nodes").StandaloneValueNode> | undefined>) => RustTypeManifest;
    visitStructFieldType: (node: import("../../nodes").StructFieldTypeNode<import("../../nodes").TypeNode, import("../../nodes").StandaloneValueNode | undefined>) => RustTypeManifest;
    visitEnumEmptyVariantType: (node: import("../../nodes").EnumEmptyVariantTypeNode) => RustTypeManifest;
    visitEnumStructVariantType: (node: import("../../nodes").EnumStructVariantTypeNode<import("../../nodes").NestedTypeNode<import("../../nodes").StructTypeNode<import("../../nodes").StructFieldTypeNode<import("../../nodes").TypeNode, import("../../nodes").StandaloneValueNode | undefined>[]>>>) => RustTypeManifest;
    visitEnumTupleVariantType: (node: import("../../nodes").EnumTupleVariantTypeNode<import("../../nodes").NestedTypeNode<import("../../nodes").TupleTypeNode<import("../../nodes").TypeNode[]>>>) => RustTypeManifest;
    visitMapEntryValue: (node: import("../../nodes").MapEntryValueNode<import("../../nodes").StandaloneValueNode, import("../../nodes").StandaloneValueNode>) => RustTypeManifest;
    visitStructFieldValue: (node: import("../../nodes").StructFieldValueNode<import("../../nodes").StandaloneValueNode>) => RustTypeManifest;
    visitRoot: (node: import("../../nodes").RootNode<import("../../nodes").ProgramNode<import("../../nodes").PdaNode<import("../../nodes").RegisteredPdaSeedNode[]>[], import("../../nodes").AccountNode<import("../../nodes").NestedTypeNode<import("../../nodes").StructTypeNode<import("../../nodes").StructFieldTypeNode<import("../../nodes").TypeNode, import("../../nodes").StandaloneValueNode | undefined>[]>>, import("../../nodes").PdaLinkNode | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined>[], import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, any[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[], import("../../nodes").DefinedTypeNode<import("../../nodes").TypeNode>[], import("../../nodes").ErrorNode[]>, import("../../nodes").ProgramNode<import("../../nodes").PdaNode<import("../../nodes").RegisteredPdaSeedNode[]>[], import("../../nodes").AccountNode<import("../../nodes").NestedTypeNode<import("../../nodes").StructTypeNode<import("../../nodes").StructFieldTypeNode<import("../../nodes").TypeNode, import("../../nodes").StandaloneValueNode | undefined>[]>>, import("../../nodes").PdaLinkNode | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined>[], import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, any[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[], import("../../nodes").DefinedTypeNode<import("../../nodes").TypeNode>[], import("../../nodes").ErrorNode[]>[]>) => RustTypeManifest;
    visitProgram: (node: import("../../nodes").ProgramNode<import("../../nodes").PdaNode<import("../../nodes").RegisteredPdaSeedNode[]>[], import("../../nodes").AccountNode<import("../../nodes").NestedTypeNode<import("../../nodes").StructTypeNode<import("../../nodes").StructFieldTypeNode<import("../../nodes").TypeNode, import("../../nodes").StandaloneValueNode | undefined>[]>>, import("../../nodes").PdaLinkNode | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined>[], import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, any[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[], import("../../nodes").DefinedTypeNode<import("../../nodes").TypeNode>[], import("../../nodes").ErrorNode[]>) => RustTypeManifest;
    visitPda: (node: import("../../nodes").PdaNode<import("../../nodes").RegisteredPdaSeedNode[]>) => RustTypeManifest;
    visitAccount: (node: import("../../nodes").AccountNode<import("../../nodes").NestedTypeNode<import("../../nodes").StructTypeNode<import("../../nodes").StructFieldTypeNode<import("../../nodes").TypeNode, import("../../nodes").StandaloneValueNode | undefined>[]>>, import("../../nodes").PdaLinkNode | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined>) => RustTypeManifest;
    visitInstructionAccount: (node: import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>) => RustTypeManifest;
    visitInstructionArgument: (node: import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>) => RustTypeManifest;
    visitInstructionByteDelta: (node: import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>) => RustTypeManifest;
    visitInstruction: (node: import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, import("../../nodes").InstructionNode<import("../../nodes").InstructionAccountNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[], import("../../nodes").InstructionArgumentNode<import("../../nodes").InstructionInputValueNode | undefined>[] | undefined, import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").InstructionByteDeltaNode<import("../../nodes").NumberValueNode | import("../../nodes").ArgumentValueNode | import("../../nodes").AccountLinkNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>[] | undefined, import("../../nodes").RegisteredDiscriminatorNode[] | undefined, any[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>[] | undefined>) => RustTypeManifest;
    visitInstructionRemainingAccounts: (node: import("../../nodes").InstructionRemainingAccountsNode<import("../../nodes").ArgumentValueNode | import("../../nodes").ResolverValueNode<(import("../../nodes").AccountValueNode | import("../../nodes").ArgumentValueNode)[]>>) => RustTypeManifest;
    visitError: (node: import("../../nodes").ErrorNode) => RustTypeManifest;
    visitDefinedType: (node: import("../../nodes").DefinedTypeNode<import("../../nodes").TypeNode>) => RustTypeManifest;
};
